# -*- coding: UTF-8 -*-

from ij import IJ
from array import array,zeros 
import colorsys
#from pylab import plot, ginput, show, axis
import copy
import sys
import os
import math
import java.awt
import ij.gui.Plot as Plot
import ij.gui.PlotWindow as PlotWindow
import java.lang.String
import java.awt.Color
import java.awt.Graphics
import java.awt.BorderLayout
from java.util import Random
import csv
import weka.classifiers.evaluation.ThresholdCurve as ThresholdCurve
import weka.classifiers.Evaluation as Evaluation
import weka.classifiers.functions.Logistic as Logistic
import weka.classifiers.functions.SMO as SMO
import weka.classifiers.trees.RandomForest as RandomForest
import weka.classifiers.meta.MultiClassClassifier as MultiClassClassifier
import weka.core.Debug as Debug
import weka.core.Instances as Instances
import weka.core.DenseInstance as DenseInstance
import weka.core.Attribute as Attribute
import weka.core.FastVector as FastVector
from javax.swing import JFrame, JLabel, JPanel, JFileChooser
import ij.process.ImageProcessor
from ij import IJ, ImagePlus, ImageStack, CompositeImage
import ij.io.DirectoryChooser as DirectoryChooser
import java.awt.Color as Color

def run():

    ############################
    #  TRAINING IMAGE DATA
    ############################
    Attribute1 = Attribute('Feature1')
    Attribute2 = Attribute('Feature2')
    Attribute3 = Attribute('Feature3')
    
    #Declare the class attribute along with its values
    fvClassVal = FastVector(3)  # zmena 2 -> 3
    fvClassVal.addElement('ClassI') # islet == 0
    fvClassVal.addElement('ClassB') # background == 1
    fvClassVal.addElement('ClassE') # background == 0.5
    ClassAttribute = Attribute('theClass', fvClassVal)
    
    #Declare the feature vector
    fvWekaAttributes = FastVector(3)
    fvWekaAttributes.addElement(Attribute1)    
    fvWekaAttributes.addElement(Attribute2)    
    fvWekaAttributes.addElement(Attribute3) 
    fvWekaAttributes.addElement(ClassAttribute)
    
    #Create an empty training set
    isTrainingSet = Instances("Rel", fvWekaAttributes, 10)           
    #Set class index
    isTrainingSet.setClassIndex(3)
    
    ############################
    # NACTENI DAT PRO TRENOVANI
    ############################
    dirChoos = DirectoryChooser("Pick a directory contained training data")
    srcDir = dirChoos.getDirectory()   
    if srcDir is None:
        frameErr1 = JFrame('ERROR', size = (300,150))
        label1 = JLabel('Directory was not opened', JLabel.CENTER)
        label1.setFont (label1.getFont().deriveFont(18.0))
        frameErr1.add(label1)
        frameErr1.visible = True
    
    #pathgt = "c:\DATA\PRACE\CMP_FEL\PRACOVNI_M_FILE\TEMPGT\"
    #pathimg = "c:\DATA\PRACE\CMP_FEL\PRACOVNI_M_FILE\TEMPGT\" 
    
    ############################
    # NASTAVENI L1outu
    # CAMERA PARAMETERS READING FROM iniL1OUT.txt
    print os.getcwd()
    finicam = open("iniTrainOnAll.txt", "r+")
    NoImgRow = finicam.readline()
    posSmc1 = NoImgRow.find(';')
    posEql1 = NoImgRow.find('=')
    prefixImgRow = finicam.readline()
    posSmc2 = prefixImgRow.find(';')
    posEql2 = prefixImgRow.find('=') 
    prefixGTRow = finicam.readline()
    posSmc3 = prefixGTRow.find(';')
    posEql3 = prefixGTRow.find('=') 
    suffixRow = finicam.readline()
    posSmc4 = suffixRow.find(';')
    posEql4 = suffixRow.find('=') 
    ROCyesnoRow = finicam.readline()
    posSmc5 = ROCyesnoRow.find(';')
    posEql5 = ROCyesnoRow.find('=')
    IniNrRow = finicam.readline()
    posSmc6 = IniNrRow.find(';')
    posEql6 = IniNrRow.find('=')
    
    try:
        NoImg = int(NoImgRow[posEql1 + 1:posSmc1]) 
        prefixImg = str(prefixImgRow[posEql2 + 1:posSmc2])
        prefixGT = str(prefixGTRow[posEql3 + 1:posSmc3])
        suffix = str(suffixRow[posEql4 + 1:posSmc4])
        ROCyesno = float(ROCyesnoRow[posEql5 + 1:posSmc5])
        IniNr = int(IniNrRow[posEql6 + 1:posSmc6])
    except:
        frameIni = JFrame('ERROR', size = (300,150))
        label = JLabel('Wrong iniTrainOnAll.txt format', JLabel.CENTER)
        frameIni.add(label)
        frameIni.visible = True     
    finicam.close()
    
    frameRun = JFrame('RUNNING ...', size = (400,100))
    
    for nr in range(IniNr,IniNr+NoImg):
        imgname = prefixImg + str(nr) + suffix
        gtname = prefixGT + str(nr) + suffix
        print imgname
        pathimg = os.path.join(srcDir,imgname)
        pathgt = os.path.join(srcDir,gtname)
        gt = IJ.openImage(pathgt) 
        imp = IJ.openImage(pathimg)
    
        labelfile = JLabel(imgname, JLabel.CENTER)  # zobrazeni segnentovanych snimku
        labelfile.setFont (labelfile.getFont().deriveFont(18.0))
        frameRun.add(labelfile)
        frameRun.visible = True
         
        IJ.run(gt,"Size...","width=512 height=384")
        IJ.run(imp,"Size...","width=512 height=384")
        ip = imp.getProcessor()#.convertToFloat() # as a copy  
        igt = gt.getProcessor().convertToFloat() # as a copy  
        piximg = ip.getPixels()
        pixgt = igt.getPixels()
        red = ip.toFloat(0, None)  
        R = red.getPixels()
        green = ip.toFloat(1, None)  
        G = green.getPixels()
        blue = ip.toFloat(2, None)  
        B = blue.getPixels()
        # CONVERTING TO HSV
        #R = colorsys.rgb_to_hsv(R,G,B)
        #print R
        Lpiximg= len(piximg)
        Lpixgt= len(pixgt)
        countBkg = 0
        countIsl = 0
        countExo = 0
        trainD = DenseInstance(4)
        for i in range(len(pixgt)):
            if pixgt[i] == 255:
                countBkg = countBkg + 1
                hsb = Color.RGBtoHSB(int(R[i]),int(G[i]),int(B[i]),None)
                #print hsb
                trainD.setValue(0,hsb[0])   # R
                trainD.setValue(1,hsb[1])     # G
                trainD.setValue(2,hsb[2])     # B
                trainD.setValue(3,0)     # 0,1; ClassI, ClassB
                isTrainingSet.add(trainD)
            elif pixgt[i] == 0:
                countIsl = countIsl + 1
                hsb = Color.RGBtoHSB(int(R[i]),int(G[i]),int(B[i]),None)
                #print hsb
                trainD.setValue(0,hsb[0])   # R
                trainD.setValue(1,hsb[1])     # G
                trainD.setValue(2,hsb[2])     # B
                trainD.setValue(3,1)     # 0,1; ClassI, ClassB
                isTrainingSet.add(trainD)
            elif pixgt[i] == 127:
                countExo = countExo + 1
                hsb = Color.RGBtoHSB(int(R[i]),int(G[i]),int(B[i]),None)
                trainD.setValue(0,hsb[0])   # R
                trainD.setValue(1,hsb[1])     # G
                trainD.setValue(2,hsb[2])     # B
                trainD.setValue(3,2)     # 0,1; ClassI, ClassB
                isTrainingSet.add(trainD)
           
        frameRun.remove(labelfile) 
    print countBkg
    print countIsl
    print countExo
    #print isTrainingSet
    
    ############################
    # BUILD CLASSIFIER
    ############################
    
    #MuClass = Logistic()  # je obsazen v MU
    #MuClass = MultiClassClassifier()
    MuClass = RandomForest() 
    #MuClass = SMO()
    #MuClass.setOptions([u'-M', u'3',u'-W', u'weka.classifiers.trees.RandomForest', u'--', u'-I', u'50', u'-K', u'2', u'-S', u'10', u'-num-slots', u'2'])
    #MuClass.setOptions([u'-M', u'3'])
    
    print MuClass.getOptions()
    #MuClass = Debug.loadFromFile("c:\DATA\PRACE\CMP_FEL\PRACOVNI_M_FILE\A1D3_SMO_BS100LBEC01_ALL")
    
    ############################
    # ROC CURVE
    ############################
    def ROCeval(isTrainingSet):
        labelROC = JLabel('ROC IS BEING COMPUTED ...', JLabel.CENTER)  # zobrazeni segnentovanych snimku
        labelROC.setFont (labelROC.getFont().deriveFont(18.0))
        frameRun.add(labelROC)
        frameRun.visible = True
    
        folds = 10
        classIndex = 0
        eval1 = Evaluation(isTrainingSet)
        eval1.crossValidateModel(MuClass,isTrainingSet,folds,Random(1))
        tc = ThresholdCurve()
        curveResults = tc.getCurve(eval1.predictions(), classIndex)
    
        FPRatt = curveResults.attribute(4)
        FPR = curveResults.attributeToDoubleArray(4)
        TPRatt = curveResults.attribute(5)
        TPR = curveResults.attributeToDoubleArray(5)
    #print FPR
    #print TPR
    
    # ROC PLOTTING
        plot = PlotWindow("ROC","FPR","TPR",FPR,TPR)
        plot.show()
        plot.setLineWidth(1)
        plot.setLimits(0,0.05,0.85,1.0)
        plot.addPoints(FPR,TPR, Plot.LINE)
        try:
            fcsv = open(str(srcDir) + '\ROC.csv', 'wb')
        except:
            frameErr = JFrame('ERROR', size = (200,200))
            label = JLabel('Close file of results', JLabel.CENTER);
            frameErr.add(label)
            frameErr.visible = True
    
        out = csv.writer(fcsv, delimiter=';')      
        rows = zip(FPR,TPR)
        for row in rows:
            out.writerow(row)
        frameRun.remove(labelROC) 
        fcsv.close()
    
    # ROC CURVE PLOTING AND SAVING
    if ROCyesno == 1:
        ROCeval(isTrainingSet)
    
    #frameRun.visible = False   # dokonceni ROC
    # SAVING OF TRAINED CLASSIFIER
    
    labelCL = JLabel('TRAINING OF A CLASSIFIER IN PROGRESS ...', JLabel.CENTER)  # zobrazeni segnentovanych snimku
    labelCL.setFont (labelCL.getFont().deriveFont(18.0))
    frameRun.add(labelCL)
    frameRun.visible = True
    
    MuClass.buildClassifier(isTrainingSet)
    frameRun.visible = False
    
    ############################
    #  CLASSIFIER SAVING
    ############################
    
    
    #Debug.saveToFile("C:\JS\KLASIFIKATORY\TEST", MuClass)
    
    
    fcS= JFileChooser('C:\JS\KLASIFIKATORY')
    #fcS= JFileChooser(srcDir)
    fcS.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES)
    fcS.setDialogTitle('Save trained classifier')
    panelS = JPanel()
    #result = fcS.showSaveDialog(panelS,"Save a trained classifier")
    result = fcS.showSaveDialog(panelS)
    
    if result == JFileChooser.APPROVE_OPTION:
        Clfile2Save = fcS.getSelectedFile()
        Clfilename2Save = fcS.getName(Clfile2Save)
    else:
        frameErr1 = JFrame('ERROR', size = (300,150))
        label1 = JLabel('Classifier was not saved', JLabel.CENTER)
        label1.setFont (label1.getFont().deriveFont(18.0))
        frameErr1.add(label1)
        frameErr1.visible = True
        
    #print Clfilename2Save
    #print Clfile2Save
    
    Debug.saveToFile(str(Clfile2Save), MuClass)
    

run()

















     